%define svnrev 216
%define svndate 20080331

Summary: Collection of SuperCollider plugins
Name: supercollider-sc3-plugins
Version: 0.%{svndate}
Release: 0.svn%{svnrev}.1%{?dist}
License: GPL
Group: Applications/Multimedia
URL: http://www2.realizedsound.net:8080/downloads/
#  svn co https://sc3-plugins.svn.sourceforge.net/svnroot/sc3-plugins sc3-plugins
Source0: sc3-plugins-svn%{svnrev}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: supercollider
Packager: Fernando Lopez-Lezcano
Distribution: Planet CCRMA
Vendor: Planet CCRMA

BuildRequires: scons subversion supercollider-devel stk

ExcludeArch: x86_64

%description
Collection of SuperCollider plugins

%package -n supercollider-beqsuite-ugens
Summary: SuperCollider equalization suite
Group: Applications/Multimedia
Epoch: 1
Obsoletes: supercollider-beqsuite-ugens <= 1:0.20070712
Provides: supercollider-beqsuite-ugens = %{version}-%{release}

%description -n supercollider-beqsuite-ugens
Equalization suite based on the Second Order Section (SOS) biquad
UGen. Includes BLowPass, BHiPass, BLowShelf, BHiShelf, BBandPass,
BBandStop, BAllPass.

%package -n supercollider-blackrain-ugens
Summary: Blackrain's SuperCollider UGens
Group: Applications/Multimedia

%description -n supercollider-blackrain-ugens
Blackrain UGen collection, includes SVF (State Variable Filter), BMoog
(yet 'nother moog impersonation), IIRFilter (24db/oct rolloff, 4nd
order resonant Low Pass Filter) and AmplitudeMod (amplitude follower).

%package -n supercollider-josh-ugens
Summary: Josh's SuperCollider UGen collection
Group: Applications/Multimedia
Epoch: 1
Obsoletes: supercollider-joshlib <= 061031
Provides: supercollider-joshlib = 1:%{version}-%{release}
Obsoletes: supercollider-jospv-ugens <= 0.20070712
Provides: supercollider-joshpv-ugens = %{version}-%{release}

%description -n supercollider-josh-ugens
ATS (Analysis, Transformation, Synthesis) resynthesis, Ambisonics
encoding and decoding, Envelopes, CSound LPC synthesis, MoogVCF,
Pluck, Warp*, Phase Vocoder UGens, etc.

%package -n supercollider-mcld-ugens
Summary: MCLD SuperCollider Ugen collection
Group: Applications/Multimedia

%description -n supercollider-mcld-ugens
Various FFT metric UGens, Chaotic generators, etc.

%package -n supercollider-membrane-ugens
Summary: Triangular waveguide meshes of a drum-like membrane
Group: Applications/Multimedia

%description -n supercollider-membrane-ugens
Here's two supercollider externs.  They're rather similar, being
triangular waveguide meshes of a drum-like membrane.  You input some
excitation, such as a pulse of noise, and can adjust the tension and
loss while it plays

%package -n supercollider-symbolic-machines
Summary: Demand rate finite state machine
Group: Applications/Multimedia

%description -n supercollider-symbolic-machines
Similar to Pfsm, Dfsm implements a markov chain. Each state has a
number of next states out of which one is randomly chosen

%package -n supercollider-tag-systems-ugens
Summary: Demand rate tag system
Group: Applications/Multimedia

%description -n supercollider-tag-systems-ugens
Demand rate tag system

%package -n supercollider-stk-ugens
Summary: STK SuperCollider UGens
Group: Applications/Multimedia
Requires: stk

%description -n supercollider-stk-ugens
This package contains a number of ports of the Stk physical
models. They are not highly optimized and initializations can be very
expensive.

%package -n supercollider-bhob-ugens
Summary: bhob SuperCollider UGens
Group: Applications/Multimedia

%description -n supercollider-bhob-ugens
Filters, Chaotic generators, Phase Vocoder UGens.

%package -n supercollider-ljpc-classes
Summary: ljpc SuperCollider class collection
Group: Applications/Multimedia

%description -n supercollider-ljpc-classes
Several scopes (graphics don't seem to work on Linux), LoopBuf.

%prep
%setup -q -n sc3-plugins-svn%{svnrev}

%build
# copy all source to the current tree, some UGens need the source and
# apparently need to write to it or touch it, arghhh....
%{__mkdir} -p SuperCollider/Headers
(cd %{_datadir}/SuperCollider; tar cf - Source)| \
(cd SuperCollider; tar xpf -)
(cd %{_includedir}/SuperCollider; tar cf - *)| \
(cd SuperCollider/Headers; tar xpf -)

# now build it with stk and ay...
scons SC3PATH=SuperCollider/ STK=yes STKPATH=/usr/lib AY=yes

# ..and create directory tree
./distro_linux

# finally remove all .svn dirs
find . -type d -name .svn | xargs %{__rm} -rf 

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}

# install the shared libraries
%{__mkdir} -p %{buildroot}%{_libdir}/SuperCollider/plugins
find . -name \*.so -exec %{__install} -m 0755 {} %{buildroot}%{_libdir}/SuperCollider/plugins/ \;

# BEQSuiteUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/BEQSuiteUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/BEQSuiteUGens
%{__cp} -pr Extensions/BEQSuiteUGens/*.sc* %{buildroot}%{_datadir}/SuperCollider/Extensions/BEQSuiteUGens
%{__cp} -pr Extensions/BEQSuiteUGens/Help/* %{buildroot}%{_datadir}/SuperCollider/Help/BEQSuiteUGens

# BlackrainUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/BlackrainUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/BlackrainUGens
%{__cp} -pr Extensions/BlackrainUGens/*.sc %{buildroot}%{_datadir}/SuperCollider/Extensions/BlackrainUGens
%{__cp} -pr Extensions/BlackrainUGens/Help/* %{buildroot}%{_datadir}/SuperCollider/Help/BlackrainUGens

# JoshUGens (includes AmbisonicUGens and JoshPVUGens)
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/JoshUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/JoshUGens
%{__cp} -pr Extensions/JoshUGens/classes/* %{buildroot}%{_datadir}/SuperCollider/Extensions/JoshUGens
%{__cp} -pr Extensions/JoshUGens/help/* %{buildroot}%{_datadir}/SuperCollider/Help/JoshUGens

# MCLD_UGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/MCLD_UGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/MCLD_UGens
%{__cp} -pr Extensions/MCLD_UGens/*.sc %{buildroot}%{_datadir}/SuperCollider/Extensions/MCLD_UGens
%{__cp} -pr Extensions/MCLD_UGens/Help/* %{buildroot}%{_datadir}/SuperCollider/Help/MCLD_UGens

# MembraneUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/MembraneUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/MembraneUGens
%{__cp} -pr Extensions/MembraneUGens/*.sc %{buildroot}%{_datadir}/SuperCollider/Extensions/MembraneUGens
%{__cp} -pr Extensions/MembraneUGens/Help/* %{buildroot}%{_datadir}/SuperCollider/Help/MembraneUGens
%{__cp} -p  Extensions/MembraneUGens/README %{buildroot}%{_datadir}/SuperCollider/Help/MembraneUGens
%{__cp} -p  Extensions/MembraneUGens/triangulation.pde %{buildroot}%{_datadir}/SuperCollider/Help/MembraneUGens

# SymbolicMachines
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/SymbolicMachines
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/SymbolicMachines
%{__cp} -pr Extensions/SymbolicMachines/*.sc %{buildroot}%{_datadir}/SuperCollider/Extensions/SymbolicMachines
%{__cp} -pr Extensions/SymbolicMachines/*.rtf %{buildroot}%{_datadir}/SuperCollider/Help/SymbolicMachines
%{__cp} -pr Extensions/SymbolicMachines/*.html %{buildroot}%{_datadir}/SuperCollider/Help/SymbolicMachines

# TagSystemUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/TagSystemUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/TagSystemUGens
%{__cp} -pr Extensions/TagSystemUGens/*.sc %{buildroot}%{_datadir}/SuperCollider/Extensions/TagSystemUGens
%{__cp} -pr Extensions/TagSystemUGens/Help/*.htm %{buildroot}%{_datadir}/SuperCollider/Help/TagSystemUGens

# StkUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/StkUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/StkUGens
%{__cp} -pr Extensions/StkUGens/*.sc %{buildroot}%{_datadir}/SuperCollider/Extensions/StkUGens
%{__cp} -pr Extensions/StkUGens/*.rtf %{buildroot}%{_datadir}/SuperCollider/Help/StkUGens

# bhobUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/bhobUGens
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/bhobUGens
%{__cp} -pr Extensions/bhobUGens/classes/* %{buildroot}%{_datadir}/SuperCollider/Extensions/bhobUGens
%{__cp} -pr Extensions/bhobUGens/help/* %{buildroot}%{_datadir}/SuperCollider/Help/bhobUGens

# ljpclasses
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Extensions/ljpclasses
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/Help/ljpclasses
%{__cp} -pr Extensions/ljpclasses/classes/* %{buildroot}%{_datadir}/SuperCollider/Extensions/ljpclasses
%{__cp} -pr Extensions/ljpclasses/help/* %{buildroot}%{_datadir}/SuperCollider/Help/ljpclasses

%clean
%{__rm} -rf %{buildroot}

%files -n supercollider-beqsuite-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/BEQSuiteUGens.so
%{_datadir}/SuperCollider/Extensions/BEQSuiteUGens
%{_datadir}/SuperCollider/Help/BEQSuiteUGens

%files -n supercollider-blackrain-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/BlackrainUGens.so
%{_datadir}/SuperCollider/Extensions/BlackrainUGens
%{_datadir}/SuperCollider/Help/BlackrainUGens

%files -n supercollider-josh-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/Josh*.so
%{_datadir}/SuperCollider/Extensions/JoshUGens
%{_datadir}/SuperCollider/Help/JoshUGens

%files -n supercollider-mcld-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/MCLD*.so
%{_libdir}/SuperCollider/plugins/AY*.so
%{_datadir}/SuperCollider/Extensions/MCLD*
%{_datadir}/SuperCollider/Help/MCLD*

%files -n supercollider-membrane-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/MembraneUGens.so
%{_datadir}/SuperCollider/Extensions/MembraneUGens
%{_datadir}/SuperCollider/Help/MembraneUGens

%files -n supercollider-symbolic-machines
%defattr(-,root,root,-)
%{_datadir}/SuperCollider/Extensions/SymbolicMachines
%{_datadir}/SuperCollider/Help/SymbolicMachines

%files -n supercollider-tag-systems-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/TagSystemUgens.so
%{_datadir}/SuperCollider/Extensions/TagSystemUGens
%{_datadir}/SuperCollider/Help/TagSystemUGens

%files -n supercollider-stk-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/StkUGens.so
%{_datadir}/SuperCollider/Extensions/StkUGens
%{_datadir}/SuperCollider/Help/StkUGens

%files -n supercollider-bhob-ugens
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/bhob*.so
%{_libdir}/SuperCollider/plugins/Bhob*.so
%{_datadir}/SuperCollider/Extensions/bhob*
%{_datadir}/SuperCollider/Extensions/bhob*/bhobFFT.sc
%{_datadir}/SuperCollider/Help/bhob*
%{_datadir}/SuperCollider/Help/bhob*/*PV*

%files -n supercollider-ljpc-classes
%defattr(-,root,root,-)
%{_libdir}/SuperCollider/plugins/LoopBuf.so
%{_datadir}/SuperCollider/Extensions/ljpc*
%{_datadir}/SuperCollider/Help/ljpc*


%changelog
* Sat Apr  5 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 0.20080331-0.svn126.1
- upgraded to current svn (revision 216)
- JoshPVUGens now merged into JoshUGens
- new: MembraneUGens, SymbolicMachines, TagSystemUGens
- removed: ReverbUGens (now part of the core SuperCollider classes)

* Sat Nov 17 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- Headers are now coming from a different location

* Fri Jul 26 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> - 0.2007.07.26-1.119svn
- updated to revision 119

* Fri Mar  9 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> - 0.20070308-1.64svn
- initial build of the sc3-plugins collection, split into multiple
  packages with each collection in a separate package (check out
  collection from svn, use svn checkout date as version, include
  svn revision in the release tag)
- fix missing include in bhobFFT.cpp (patch0)
- do not build bhobFFT plugins or install the FFT class or the PV 
  help files, the plugin fails to link properly:

ldd -r -d bhobFFT.so
undefined symbol: _Z17initPV_ThirdPartyP14InterfaceTable        (./bhobFFT.so)
undefined symbol: _Z12ToComplexApxP6SndBuf      (./bhobFFT.so)
undefined symbol: _Z10ToPolarApxP6SndBuf        (./bhobFFT.so)
        linux-gate.so.1 =>  (0xffffe000)
        libstdc++.so.6 => /usr/lib/libstdc++.so.6 (0xf7f07000)
        libm.so.6 => /lib/libm.so.6 (0xf7ee2000)
        libgcc_s.so.1 => /lib/libgcc_s.so.1 (0xf7ed8000)
        libc.so.6 => /lib/libc.so.6 (0xf7daf000)
        /lib/ld-linux.so.2 (0x56555000)
